"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

var _TransactionModel = _interopRequireDefault(require("../model/TransactionModel"));

var _V1CurrenciesCurrencyIdBatchTransfersPostRequest = _interopRequireDefault(require("../model/V1CurrenciesCurrencyIdBatchTransfersPostRequest"));

var _V1CurrenciesCurrencyIdBurnsPostRequest = _interopRequireDefault(require("../model/V1CurrenciesCurrencyIdBurnsPostRequest"));

var _V1CurrenciesCurrencyIdFeesGet200Response = _interopRequireDefault(require("../model/V1CurrenciesCurrencyIdFeesGet200Response"));

var _V1CurrenciesCurrencyIdFeesGetRequest = _interopRequireDefault(require("../model/V1CurrenciesCurrencyIdFeesGetRequest"));

var _V1CurrenciesCurrencyIdMintsPostRequest = _interopRequireDefault(require("../model/V1CurrenciesCurrencyIdMintsPostRequest"));

var _V1CurrenciesCurrencyIdTransfersPostRequest = _interopRequireDefault(require("../model/V1CurrenciesCurrencyIdTransfersPostRequest"));

var _V1CurrenciesGet200Response = _interopRequireDefault(require("../model/V1CurrenciesGet200Response"));

var _V1CurrenciesGet200ResponseInner = _interopRequireDefault(require("../model/V1CurrenciesGet200ResponseInner"));

var _V1CurrenciesGetRequest = _interopRequireDefault(require("../model/V1CurrenciesGetRequest"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
* Currencies service.
* @module metafab-javascript/CurrenciesApi
* @version 1.0.0
*/
var CurrenciesApi = /*#__PURE__*/function () {
  /**
  * Constructs a new CurrenciesApi. 
  * @alias module:metafab-javascript/CurrenciesApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  function CurrenciesApi(apiClient) {
    _classCallCheck(this, CurrenciesApi);

    this.apiClient = apiClient || _ApiClient["default"].instance;
  }
  /**
   * Get currency balance
   * Returns the current currency balance of the provided wallet address or or the wallet address associated with the provided walletId.
   * @param {String} currencyId Any currency id within the MetaFab ecosystem.
   * @param {Object} opts Optional parameters
   * @param {String} opts.address A valid EVM based address. For example, `0x39cb70F972E0EE920088AeF97Dbe5c6251a9c25D`.
   * @param {String} opts.walletId Any wallet id within the MetaFab ecosystem.
   * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Number} and HTTP response
   */


  _createClass(CurrenciesApi, [{
    key: "v1CurrenciesCurrencyIdBalancesGetWithHttpInfo",
    value: function v1CurrenciesCurrencyIdBalancesGetWithHttpInfo(currencyId, opts) {
      opts = opts || {};
      var postBody = null; // verify the required parameter 'currencyId' is set

      if (currencyId === undefined || currencyId === null) {
        throw new Error("Missing the required parameter 'currencyId' when calling v1CurrenciesCurrencyIdBalancesGet");
      }

      var pathParams = {
        'currencyId': currencyId
      };
      var queryParams = {
        'address': opts['address'],
        'walletId': opts['walletId']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = 'Number';
      return this.apiClient.callApi('/v1/currencies/{currencyId}/balances', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Get currency balance
     * Returns the current currency balance of the provided wallet address or or the wallet address associated with the provided walletId.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {Object} opts Optional parameters
     * @param {String} opts.address A valid EVM based address. For example, `0x39cb70F972E0EE920088AeF97Dbe5c6251a9c25D`.
     * @param {String} opts.walletId Any wallet id within the MetaFab ecosystem.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Number}
     */

  }, {
    key: "v1CurrenciesCurrencyIdBalancesGet",
    value: function v1CurrenciesCurrencyIdBalancesGet(currencyId, opts) {
      return this.v1CurrenciesCurrencyIdBalancesGetWithHttpInfo(currencyId, opts).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
    /**
     * Batch transfer currency
     * Transfers multiple amounts of currency to multiple provided wallet addresses or wallet addresses associated with the provided walletIds. You may also provide a combination of addresses and walletIds in one request, the proper receipients will be automatically determined, with `addresses` getting `amounts` order priority first. Optional references may be included for the transfer. References are useful for identifying transfers intended to pay for items, trades, services and more.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of a specific game or the `accessToken` of a specific player.
     * @param {String} xPassword The password of the authenticating game or player. Required to decrypt and perform blockchain transactions with the game or player primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdBatchTransfersPostRequest} v1CurrenciesCurrencyIdBatchTransfersPostRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TransactionModel} and HTTP response
     */

  }, {
    key: "v1CurrenciesCurrencyIdBatchTransfersPostWithHttpInfo",
    value: function v1CurrenciesCurrencyIdBatchTransfersPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdBatchTransfersPostRequest) {
      var postBody = v1CurrenciesCurrencyIdBatchTransfersPostRequest; // verify the required parameter 'currencyId' is set

      if (currencyId === undefined || currencyId === null) {
        throw new Error("Missing the required parameter 'currencyId' when calling v1CurrenciesCurrencyIdBatchTransfersPost");
      } // verify the required parameter 'xAuthorization' is set


      if (xAuthorization === undefined || xAuthorization === null) {
        throw new Error("Missing the required parameter 'xAuthorization' when calling v1CurrenciesCurrencyIdBatchTransfersPost");
      } // verify the required parameter 'xPassword' is set


      if (xPassword === undefined || xPassword === null) {
        throw new Error("Missing the required parameter 'xPassword' when calling v1CurrenciesCurrencyIdBatchTransfersPost");
      } // verify the required parameter 'v1CurrenciesCurrencyIdBatchTransfersPostRequest' is set


      if (v1CurrenciesCurrencyIdBatchTransfersPostRequest === undefined || v1CurrenciesCurrencyIdBatchTransfersPostRequest === null) {
        throw new Error("Missing the required parameter 'v1CurrenciesCurrencyIdBatchTransfersPostRequest' when calling v1CurrenciesCurrencyIdBatchTransfersPost");
      }

      var pathParams = {
        'currencyId': currencyId
      };
      var queryParams = {};
      var headerParams = {
        'X-Authorization': xAuthorization,
        'X-Password': xPassword
      };
      var formParams = {};
      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = _TransactionModel["default"];
      return this.apiClient.callApi('/v1/currencies/{currencyId}/batchTransfers', 'POST', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Batch transfer currency
     * Transfers multiple amounts of currency to multiple provided wallet addresses or wallet addresses associated with the provided walletIds. You may also provide a combination of addresses and walletIds in one request, the proper receipients will be automatically determined, with `addresses` getting `amounts` order priority first. Optional references may be included for the transfer. References are useful for identifying transfers intended to pay for items, trades, services and more.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of a specific game or the `accessToken` of a specific player.
     * @param {String} xPassword The password of the authenticating game or player. Required to decrypt and perform blockchain transactions with the game or player primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdBatchTransfersPostRequest} v1CurrenciesCurrencyIdBatchTransfersPostRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TransactionModel}
     */

  }, {
    key: "v1CurrenciesCurrencyIdBatchTransfersPost",
    value: function v1CurrenciesCurrencyIdBatchTransfersPost(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdBatchTransfersPostRequest) {
      return this.v1CurrenciesCurrencyIdBatchTransfersPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdBatchTransfersPostRequest).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
    /**
     * Burn currency
     * Removes (burns) the provided amount of currency from the authenticating game or players wallet. The currency amount is permanently removed from the circulating supply of the currency.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of a specific game or the `accessToken` of a specific player.
     * @param {String} xPassword The password of the authenticating game or player. Required to decrypt and perform blockchain transactions with the game or player primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdBurnsPostRequest} v1CurrenciesCurrencyIdBurnsPostRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TransactionModel} and HTTP response
     */

  }, {
    key: "v1CurrenciesCurrencyIdBurnsPostWithHttpInfo",
    value: function v1CurrenciesCurrencyIdBurnsPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdBurnsPostRequest) {
      var postBody = v1CurrenciesCurrencyIdBurnsPostRequest; // verify the required parameter 'currencyId' is set

      if (currencyId === undefined || currencyId === null) {
        throw new Error("Missing the required parameter 'currencyId' when calling v1CurrenciesCurrencyIdBurnsPost");
      } // verify the required parameter 'xAuthorization' is set


      if (xAuthorization === undefined || xAuthorization === null) {
        throw new Error("Missing the required parameter 'xAuthorization' when calling v1CurrenciesCurrencyIdBurnsPost");
      } // verify the required parameter 'xPassword' is set


      if (xPassword === undefined || xPassword === null) {
        throw new Error("Missing the required parameter 'xPassword' when calling v1CurrenciesCurrencyIdBurnsPost");
      } // verify the required parameter 'v1CurrenciesCurrencyIdBurnsPostRequest' is set


      if (v1CurrenciesCurrencyIdBurnsPostRequest === undefined || v1CurrenciesCurrencyIdBurnsPostRequest === null) {
        throw new Error("Missing the required parameter 'v1CurrenciesCurrencyIdBurnsPostRequest' when calling v1CurrenciesCurrencyIdBurnsPost");
      }

      var pathParams = {
        'currencyId': currencyId
      };
      var queryParams = {};
      var headerParams = {
        'X-Authorization': xAuthorization,
        'X-Password': xPassword
      };
      var formParams = {};
      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = _TransactionModel["default"];
      return this.apiClient.callApi('/v1/currencies/{currencyId}/burns', 'POST', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Burn currency
     * Removes (burns) the provided amount of currency from the authenticating game or players wallet. The currency amount is permanently removed from the circulating supply of the currency.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of a specific game or the `accessToken` of a specific player.
     * @param {String} xPassword The password of the authenticating game or player. Required to decrypt and perform blockchain transactions with the game or player primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdBurnsPostRequest} v1CurrenciesCurrencyIdBurnsPostRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TransactionModel}
     */

  }, {
    key: "v1CurrenciesCurrencyIdBurnsPost",
    value: function v1CurrenciesCurrencyIdBurnsPost(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdBurnsPostRequest) {
      return this.v1CurrenciesCurrencyIdBurnsPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdBurnsPostRequest).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
    /**
     * Get currency fees
     * Returns the current fee recipient address and fees of the currency for the provided currencyId. Fees are only applicable for gasless transactions performed by default by players.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/V1CurrenciesCurrencyIdFeesGet200Response} and HTTP response
     */

  }, {
    key: "v1CurrenciesCurrencyIdFeesGetWithHttpInfo",
    value: function v1CurrenciesCurrencyIdFeesGetWithHttpInfo(currencyId) {
      var postBody = null; // verify the required parameter 'currencyId' is set

      if (currencyId === undefined || currencyId === null) {
        throw new Error("Missing the required parameter 'currencyId' when calling v1CurrenciesCurrencyIdFeesGet");
      }

      var pathParams = {
        'currencyId': currencyId
      };
      var queryParams = {};
      var headerParams = {};
      var formParams = {};
      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _V1CurrenciesCurrencyIdFeesGet200Response["default"];
      return this.apiClient.callApi('/v1/currencies/{currencyId}/fees', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Get currency fees
     * Returns the current fee recipient address and fees of the currency for the provided currencyId. Fees are only applicable for gasless transactions performed by default by players.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/V1CurrenciesCurrencyIdFeesGet200Response}
     */

  }, {
    key: "v1CurrenciesCurrencyIdFeesGet",
    value: function v1CurrenciesCurrencyIdFeesGet(currencyId) {
      return this.v1CurrenciesCurrencyIdFeesGetWithHttpInfo(currencyId).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
    /**
     * Set currency fees
     * Sets the recipient address, basis points, fixed amount and cap amount for a currency's fees.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of the authenticating game.
     * @param {String} xPassword The password of the authenticating game. Required to decrypt and perform blockchain transactions with the game primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdFeesGetRequest} v1CurrenciesCurrencyIdFeesGetRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TransactionModel} and HTTP response
     */

  }, {
    key: "v1CurrenciesCurrencyIdFeesPostWithHttpInfo",
    value: function v1CurrenciesCurrencyIdFeesPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdFeesGetRequest) {
      var postBody = v1CurrenciesCurrencyIdFeesGetRequest; // verify the required parameter 'currencyId' is set

      if (currencyId === undefined || currencyId === null) {
        throw new Error("Missing the required parameter 'currencyId' when calling v1CurrenciesCurrencyIdFeesPost");
      } // verify the required parameter 'xAuthorization' is set


      if (xAuthorization === undefined || xAuthorization === null) {
        throw new Error("Missing the required parameter 'xAuthorization' when calling v1CurrenciesCurrencyIdFeesPost");
      } // verify the required parameter 'xPassword' is set


      if (xPassword === undefined || xPassword === null) {
        throw new Error("Missing the required parameter 'xPassword' when calling v1CurrenciesCurrencyIdFeesPost");
      } // verify the required parameter 'v1CurrenciesCurrencyIdFeesGetRequest' is set


      if (v1CurrenciesCurrencyIdFeesGetRequest === undefined || v1CurrenciesCurrencyIdFeesGetRequest === null) {
        throw new Error("Missing the required parameter 'v1CurrenciesCurrencyIdFeesGetRequest' when calling v1CurrenciesCurrencyIdFeesPost");
      }

      var pathParams = {
        'currencyId': currencyId
      };
      var queryParams = {};
      var headerParams = {
        'X-Authorization': xAuthorization,
        'X-Password': xPassword
      };
      var formParams = {};
      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = _TransactionModel["default"];
      return this.apiClient.callApi('/v1/currencies/{currencyId}/fees', 'POST', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Set currency fees
     * Sets the recipient address, basis points, fixed amount and cap amount for a currency's fees.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of the authenticating game.
     * @param {String} xPassword The password of the authenticating game. Required to decrypt and perform blockchain transactions with the game primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdFeesGetRequest} v1CurrenciesCurrencyIdFeesGetRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TransactionModel}
     */

  }, {
    key: "v1CurrenciesCurrencyIdFeesPost",
    value: function v1CurrenciesCurrencyIdFeesPost(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdFeesGetRequest) {
      return this.v1CurrenciesCurrencyIdFeesPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdFeesGetRequest).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
    /**
     * Mint currency
     * Creates (mints) the provided amount of currency  to the provided wallet address or wallet address associated with the provided walletId.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of the authenticating game.
     * @param {String} xPassword The password of the authenticating game. Required to decrypt and perform blockchain transactions with the game primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdMintsPostRequest} v1CurrenciesCurrencyIdMintsPostRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TransactionModel} and HTTP response
     */

  }, {
    key: "v1CurrenciesCurrencyIdMintsPostWithHttpInfo",
    value: function v1CurrenciesCurrencyIdMintsPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdMintsPostRequest) {
      var postBody = v1CurrenciesCurrencyIdMintsPostRequest; // verify the required parameter 'currencyId' is set

      if (currencyId === undefined || currencyId === null) {
        throw new Error("Missing the required parameter 'currencyId' when calling v1CurrenciesCurrencyIdMintsPost");
      } // verify the required parameter 'xAuthorization' is set


      if (xAuthorization === undefined || xAuthorization === null) {
        throw new Error("Missing the required parameter 'xAuthorization' when calling v1CurrenciesCurrencyIdMintsPost");
      } // verify the required parameter 'xPassword' is set


      if (xPassword === undefined || xPassword === null) {
        throw new Error("Missing the required parameter 'xPassword' when calling v1CurrenciesCurrencyIdMintsPost");
      } // verify the required parameter 'v1CurrenciesCurrencyIdMintsPostRequest' is set


      if (v1CurrenciesCurrencyIdMintsPostRequest === undefined || v1CurrenciesCurrencyIdMintsPostRequest === null) {
        throw new Error("Missing the required parameter 'v1CurrenciesCurrencyIdMintsPostRequest' when calling v1CurrenciesCurrencyIdMintsPost");
      }

      var pathParams = {
        'currencyId': currencyId
      };
      var queryParams = {};
      var headerParams = {
        'X-Authorization': xAuthorization,
        'X-Password': xPassword
      };
      var formParams = {};
      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = _TransactionModel["default"];
      return this.apiClient.callApi('/v1/currencies/{currencyId}/mints', 'POST', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Mint currency
     * Creates (mints) the provided amount of currency  to the provided wallet address or wallet address associated with the provided walletId.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of the authenticating game.
     * @param {String} xPassword The password of the authenticating game. Required to decrypt and perform blockchain transactions with the game primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdMintsPostRequest} v1CurrenciesCurrencyIdMintsPostRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TransactionModel}
     */

  }, {
    key: "v1CurrenciesCurrencyIdMintsPost",
    value: function v1CurrenciesCurrencyIdMintsPost(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdMintsPostRequest) {
      return this.v1CurrenciesCurrencyIdMintsPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdMintsPostRequest).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
    /**
     * Transfer currency
     * Transfers an amount of currency to the provided wallet address or wallet address associated with the provided walletId. If you want to transfer to multiple wallets with different amounts and optional references in one API request, please see the Batch transfer currency documentation.  An optional reference may be included for the transfer. References are useful for identifying transfers intended to pay for items, trades, services and more.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of a specific game or the `accessToken` of a specific player.
     * @param {String} xPassword The password of the authenticating game or player. Required to decrypt and perform blockchain transactions with the game or player primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdTransfersPostRequest} v1CurrenciesCurrencyIdTransfersPostRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TransactionModel} and HTTP response
     */

  }, {
    key: "v1CurrenciesCurrencyIdTransfersPostWithHttpInfo",
    value: function v1CurrenciesCurrencyIdTransfersPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdTransfersPostRequest) {
      var postBody = v1CurrenciesCurrencyIdTransfersPostRequest; // verify the required parameter 'currencyId' is set

      if (currencyId === undefined || currencyId === null) {
        throw new Error("Missing the required parameter 'currencyId' when calling v1CurrenciesCurrencyIdTransfersPost");
      } // verify the required parameter 'xAuthorization' is set


      if (xAuthorization === undefined || xAuthorization === null) {
        throw new Error("Missing the required parameter 'xAuthorization' when calling v1CurrenciesCurrencyIdTransfersPost");
      } // verify the required parameter 'xPassword' is set


      if (xPassword === undefined || xPassword === null) {
        throw new Error("Missing the required parameter 'xPassword' when calling v1CurrenciesCurrencyIdTransfersPost");
      } // verify the required parameter 'v1CurrenciesCurrencyIdTransfersPostRequest' is set


      if (v1CurrenciesCurrencyIdTransfersPostRequest === undefined || v1CurrenciesCurrencyIdTransfersPostRequest === null) {
        throw new Error("Missing the required parameter 'v1CurrenciesCurrencyIdTransfersPostRequest' when calling v1CurrenciesCurrencyIdTransfersPost");
      }

      var pathParams = {
        'currencyId': currencyId
      };
      var queryParams = {};
      var headerParams = {
        'X-Authorization': xAuthorization,
        'X-Password': xPassword
      };
      var formParams = {};
      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = _TransactionModel["default"];
      return this.apiClient.callApi('/v1/currencies/{currencyId}/transfers', 'POST', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Transfer currency
     * Transfers an amount of currency to the provided wallet address or wallet address associated with the provided walletId. If you want to transfer to multiple wallets with different amounts and optional references in one API request, please see the Batch transfer currency documentation.  An optional reference may be included for the transfer. References are useful for identifying transfers intended to pay for items, trades, services and more.
     * @param {String} currencyId Any currency id within the MetaFab ecosystem.
     * @param {String} xAuthorization The `secretKey` of a specific game or the `accessToken` of a specific player.
     * @param {String} xPassword The password of the authenticating game or player. Required to decrypt and perform blockchain transactions with the game or player primary wallet.
     * @param {module:model/V1CurrenciesCurrencyIdTransfersPostRequest} v1CurrenciesCurrencyIdTransfersPostRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TransactionModel}
     */

  }, {
    key: "v1CurrenciesCurrencyIdTransfersPost",
    value: function v1CurrenciesCurrencyIdTransfersPost(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdTransfersPostRequest) {
      return this.v1CurrenciesCurrencyIdTransfersPostWithHttpInfo(currencyId, xAuthorization, xPassword, v1CurrenciesCurrencyIdTransfersPostRequest).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
    /**
     * Get currencies
     * Returns an array of active currencies for the game associated with the provided `X-Game-Key`.
     * @param {String} xGameKey The `publishedKey` of a specific game. This can be shared or included in game clients, websites, etc.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/V1CurrenciesGet200ResponseInner>} and HTTP response
     */

  }, {
    key: "v1CurrenciesGetWithHttpInfo",
    value: function v1CurrenciesGetWithHttpInfo(xGameKey) {
      var postBody = null; // verify the required parameter 'xGameKey' is set

      if (xGameKey === undefined || xGameKey === null) {
        throw new Error("Missing the required parameter 'xGameKey' when calling v1CurrenciesGet");
      }

      var pathParams = {};
      var queryParams = {};
      var headerParams = {
        'X-Game-Key': xGameKey
      };
      var formParams = {};
      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [_V1CurrenciesGet200ResponseInner["default"]];
      return this.apiClient.callApi('/v1/currencies', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Get currencies
     * Returns an array of active currencies for the game associated with the provided `X-Game-Key`.
     * @param {String} xGameKey The `publishedKey` of a specific game. This can be shared or included in game clients, websites, etc.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/V1CurrenciesGet200ResponseInner>}
     */

  }, {
    key: "v1CurrenciesGet",
    value: function v1CurrenciesGet(xGameKey) {
      return this.v1CurrenciesGetWithHttpInfo(xGameKey).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
    /**
     * Create currency
     * Creates a new game currency and deploys an ERC20 token contract on behalf of the authenticating game's primary wallet. The deployed ERC20 contract is preconfigured to fully support bridging across blockchains, batched transfers and gasless transactions on any supported blockchain as well as full support for gasless transactions from player managed wallets.
     * @param {String} xAuthorization The `secretKey` of the authenticating game.
     * @param {String} xPassword The password of the authenticating game. Required to decrypt and perform blockchain transactions with the game primary wallet.
     * @param {module:model/V1CurrenciesGetRequest} v1CurrenciesGetRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/V1CurrenciesGet200Response} and HTTP response
     */

  }, {
    key: "v1CurrenciesPostWithHttpInfo",
    value: function v1CurrenciesPostWithHttpInfo(xAuthorization, xPassword, v1CurrenciesGetRequest) {
      var postBody = v1CurrenciesGetRequest; // verify the required parameter 'xAuthorization' is set

      if (xAuthorization === undefined || xAuthorization === null) {
        throw new Error("Missing the required parameter 'xAuthorization' when calling v1CurrenciesPost");
      } // verify the required parameter 'xPassword' is set


      if (xPassword === undefined || xPassword === null) {
        throw new Error("Missing the required parameter 'xPassword' when calling v1CurrenciesPost");
      } // verify the required parameter 'v1CurrenciesGetRequest' is set


      if (v1CurrenciesGetRequest === undefined || v1CurrenciesGetRequest === null) {
        throw new Error("Missing the required parameter 'v1CurrenciesGetRequest' when calling v1CurrenciesPost");
      }

      var pathParams = {};
      var queryParams = {};
      var headerParams = {
        'X-Authorization': xAuthorization,
        'X-Password': xPassword
      };
      var formParams = {};
      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = _V1CurrenciesGet200Response["default"];
      return this.apiClient.callApi('/v1/currencies', 'POST', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
    }
    /**
     * Create currency
     * Creates a new game currency and deploys an ERC20 token contract on behalf of the authenticating game's primary wallet. The deployed ERC20 contract is preconfigured to fully support bridging across blockchains, batched transfers and gasless transactions on any supported blockchain as well as full support for gasless transactions from player managed wallets.
     * @param {String} xAuthorization The `secretKey` of the authenticating game.
     * @param {String} xPassword The password of the authenticating game. Required to decrypt and perform blockchain transactions with the game primary wallet.
     * @param {module:model/V1CurrenciesGetRequest} v1CurrenciesGetRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/V1CurrenciesGet200Response}
     */

  }, {
    key: "v1CurrenciesPost",
    value: function v1CurrenciesPost(xAuthorization, xPassword, v1CurrenciesGetRequest) {
      return this.v1CurrenciesPostWithHttpInfo(xAuthorization, xPassword, v1CurrenciesGetRequest).then(function (response_and_data) {
        return response_and_data.data;
      });
    }
  }]);

  return CurrenciesApi;
}();

exports["default"] = CurrenciesApi;