"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The BatchTransferCurrencyRequest model module.
 * @module model/BatchTransferCurrencyRequest
 * @version 1.0.1
 */
var BatchTransferCurrencyRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>BatchTransferCurrencyRequest</code>.
   * @alias module:model/BatchTransferCurrencyRequest
   * @param amounts {Array.<Number>} An array of currency amounts to transfer. Ordering corresponds to the ordering of provided `addresses` and/or `walletIds`. If both `addresses` and `walletIds` are provided, `addresses` are first in the order.
   */
  function BatchTransferCurrencyRequest(amounts) {
    _classCallCheck(this, BatchTransferCurrencyRequest);

    BatchTransferCurrencyRequest.initialize(this, amounts);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(BatchTransferCurrencyRequest, null, [{
    key: "initialize",
    value: function initialize(obj, amounts) {
      obj['amounts'] = amounts;
    }
    /**
     * Constructs a <code>BatchTransferCurrencyRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BatchTransferCurrencyRequest} obj Optional instance to populate.
     * @return {module:model/BatchTransferCurrencyRequest} The populated <code>BatchTransferCurrencyRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new BatchTransferCurrencyRequest();

        if (data.hasOwnProperty('addresses')) {
          obj['addresses'] = _ApiClient["default"].convertToType(data['addresses'], ['String']);
        }

        if (data.hasOwnProperty('walletIds')) {
          obj['walletIds'] = _ApiClient["default"].convertToType(data['walletIds'], ['String']);
        }

        if (data.hasOwnProperty('amounts')) {
          obj['amounts'] = _ApiClient["default"].convertToType(data['amounts'], ['Number']);
        }

        if (data.hasOwnProperty('references')) {
          obj['references'] = _ApiClient["default"].convertToType(data['references'], ['Number']);
        }
      }

      return obj;
    }
  }]);

  return BatchTransferCurrencyRequest;
}();
/**
 * An array of valid EVM based addresses to transfer currency to.
 * @member {Array.<String>} addresses
 */


BatchTransferCurrencyRequest.prototype['addresses'] = undefined;
/**
 * An array of wallet ids within the MetaFab ecosystem to transfer currency to.
 * @member {Array.<String>} walletIds
 */

BatchTransferCurrencyRequest.prototype['walletIds'] = undefined;
/**
 * An array of currency amounts to transfer. Ordering corresponds to the ordering of provided `addresses` and/or `walletIds`. If both `addresses` and `walletIds` are provided, `addresses` are first in the order.
 * @member {Array.<Number>} amounts
 */

BatchTransferCurrencyRequest.prototype['amounts'] = undefined;
/**
 * An optional array of uint256 numbers to reference each transfer in the batch. Ordering corresponds to the ordering of provided `addresses` or `walletIds`. If both `addresses` and `walletIds` are provided, `addresses` are first in the order.
 * @member {Array.<Number>} references
 */

BatchTransferCurrencyRequest.prototype['references'] = undefined;
var _default = BatchTransferCurrencyRequest;
exports["default"] = _default;