"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The CreateContractRequest model module.
 * @module model/CreateContractRequest
 * @version 1.0.1
 */
var CreateContractRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>CreateContractRequest</code>.
   * @alias module:model/CreateContractRequest
   * @param address {String} The address of the existing contract.
   * @param abi {String} JSON of the abi.
   * @param chain {module:model/CreateContractRequest.ChainEnum} The blockchain you want to deploy this currency on. Support for new blockchains are added over time.
   */
  function CreateContractRequest(address, abi, chain) {
    _classCallCheck(this, CreateContractRequest);

    CreateContractRequest.initialize(this, address, abi, chain);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(CreateContractRequest, null, [{
    key: "initialize",
    value: function initialize(obj, address, abi, chain) {
      obj['address'] = address;
      obj['abi'] = abi;
      obj['chain'] = chain;
    }
    /**
     * Constructs a <code>CreateContractRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/CreateContractRequest} obj Optional instance to populate.
     * @return {module:model/CreateContractRequest} The populated <code>CreateContractRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new CreateContractRequest();

        if (data.hasOwnProperty('address')) {
          obj['address'] = _ApiClient["default"].convertToType(data['address'], 'String');
        }

        if (data.hasOwnProperty('abi')) {
          obj['abi'] = _ApiClient["default"].convertToType(data['abi'], 'String');
        }

        if (data.hasOwnProperty('chain')) {
          obj['chain'] = _ApiClient["default"].convertToType(data['chain'], 'String');
        }
      }

      return obj;
    }
  }]);

  return CreateContractRequest;
}();
/**
 * The address of the existing contract.
 * @member {String} address
 */


CreateContractRequest.prototype['address'] = undefined;
/**
 * JSON of the abi.
 * @member {String} abi
 */

CreateContractRequest.prototype['abi'] = undefined;
/**
 * The blockchain you want to deploy this currency on. Support for new blockchains are added over time.
 * @member {module:model/CreateContractRequest.ChainEnum} chain
 */

CreateContractRequest.prototype['chain'] = undefined;
/**
 * Allowed values for the <code>chain</code> property.
 * @enum {String}
 * @readonly
 */

CreateContractRequest['ChainEnum'] = {
  /**
   * value: "ETHEREUM"
   * @const
   */
  "ETHEREUM": "ETHEREUM",

  /**
   * value: "GOERLI"
   * @const
   */
  "GOERLI": "GOERLI",

  /**
   * value: "MATIC"
   * @const
   */
  "MATIC": "MATIC",

  /**
   * value: "MUMBAI"
   * @const
   */
  "MUMBAI": "MUMBAI"
};
var _default = CreateContractRequest;
exports["default"] = _default;