"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The CreateCurrencyRequest model module.
 * @module model/CreateCurrencyRequest
 * @version 1.0.1
 */
var CreateCurrencyRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>CreateCurrencyRequest</code>.
   * @alias module:model/CreateCurrencyRequest
   * @param name {String} The name of this currency. This can be anything, such as `Bright Gems`, `Gold`, etc.
   * @param symbol {String} The shorthand symbol to represent this currency. This can be anything, such as `BGEM`, `GLD`, etc.
   * @param supplyCap {Number} The maximum amount of this currency that can ever exist. Use `0` if you do not want this currency to have a maximum supply.
   * @param chain {module:model/CreateCurrencyRequest.ChainEnum} The blockchain you want to deploy this currency on. Support for new blockchains are added over time.
   */
  function CreateCurrencyRequest(name, symbol, supplyCap, chain) {
    _classCallCheck(this, CreateCurrencyRequest);

    CreateCurrencyRequest.initialize(this, name, symbol, supplyCap, chain);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(CreateCurrencyRequest, null, [{
    key: "initialize",
    value: function initialize(obj, name, symbol, supplyCap, chain) {
      obj['name'] = name;
      obj['symbol'] = symbol;
      obj['supplyCap'] = supplyCap;
      obj['chain'] = chain;
    }
    /**
     * Constructs a <code>CreateCurrencyRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/CreateCurrencyRequest} obj Optional instance to populate.
     * @return {module:model/CreateCurrencyRequest} The populated <code>CreateCurrencyRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new CreateCurrencyRequest();

        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }

        if (data.hasOwnProperty('symbol')) {
          obj['symbol'] = _ApiClient["default"].convertToType(data['symbol'], 'String');
        }

        if (data.hasOwnProperty('supplyCap')) {
          obj['supplyCap'] = _ApiClient["default"].convertToType(data['supplyCap'], 'Number');
        }

        if (data.hasOwnProperty('chain')) {
          obj['chain'] = _ApiClient["default"].convertToType(data['chain'], 'String');
        }
      }

      return obj;
    }
  }]);

  return CreateCurrencyRequest;
}();
/**
 * The name of this currency. This can be anything, such as `Bright Gems`, `Gold`, etc.
 * @member {String} name
 */


CreateCurrencyRequest.prototype['name'] = undefined;
/**
 * The shorthand symbol to represent this currency. This can be anything, such as `BGEM`, `GLD`, etc.
 * @member {String} symbol
 */

CreateCurrencyRequest.prototype['symbol'] = undefined;
/**
 * The maximum amount of this currency that can ever exist. Use `0` if you do not want this currency to have a maximum supply.
 * @member {Number} supplyCap
 */

CreateCurrencyRequest.prototype['supplyCap'] = undefined;
/**
 * The blockchain you want to deploy this currency on. Support for new blockchains are added over time.
 * @member {module:model/CreateCurrencyRequest.ChainEnum} chain
 */

CreateCurrencyRequest.prototype['chain'] = undefined;
/**
 * Allowed values for the <code>chain</code> property.
 * @enum {String}
 * @readonly
 */

CreateCurrencyRequest['ChainEnum'] = {
  /**
   * value: "ETHEREUM"
   * @const
   */
  "ETHEREUM": "ETHEREUM",

  /**
   * value: "GOERLI"
   * @const
   */
  "GOERLI": "GOERLI",

  /**
   * value: "MATIC"
   * @const
   */
  "MATIC": "MATIC",

  /**
   * value: "MUMBAI"
   * @const
   */
  "MUMBAI": "MUMBAI"
};
var _default = CreateCurrencyRequest;
exports["default"] = _default;