"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The CreateGameRequest model module.
 * @module model/CreateGameRequest
 * @version 1.0.1
 */
var CreateGameRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>CreateGameRequest</code>.
   * @alias module:model/CreateGameRequest
   * @param name {String} The name of the game you're creating.
   * @param email {String} The email address associated with this game and used to login/authenticate as the game.
   * @param password {String} The password to authenticate as the game. Additionally, this password is used to encrypt/decrypt your game's primary wallet and must be provided anytime this game makes blockchain interactions through various endpoints.
   */
  function CreateGameRequest(name, email, password) {
    _classCallCheck(this, CreateGameRequest);

    CreateGameRequest.initialize(this, name, email, password);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(CreateGameRequest, null, [{
    key: "initialize",
    value: function initialize(obj, name, email, password) {
      obj['name'] = name;
      obj['email'] = email;
      obj['password'] = password;
    }
    /**
     * Constructs a <code>CreateGameRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/CreateGameRequest} obj Optional instance to populate.
     * @return {module:model/CreateGameRequest} The populated <code>CreateGameRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new CreateGameRequest();

        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }

        if (data.hasOwnProperty('email')) {
          obj['email'] = _ApiClient["default"].convertToType(data['email'], 'String');
        }

        if (data.hasOwnProperty('password')) {
          obj['password'] = _ApiClient["default"].convertToType(data['password'], 'String');
        }
      }

      return obj;
    }
  }]);

  return CreateGameRequest;
}();
/**
 * The name of the game you're creating.
 * @member {String} name
 */


CreateGameRequest.prototype['name'] = undefined;
/**
 * The email address associated with this game and used to login/authenticate as the game.
 * @member {String} email
 */

CreateGameRequest.prototype['email'] = undefined;
/**
 * The password to authenticate as the game. Additionally, this password is used to encrypt/decrypt your game's primary wallet and must be provided anytime this game makes blockchain interactions through various endpoints.
 * @member {String} password
 */

CreateGameRequest.prototype['password'] = undefined;
var _default = CreateGameRequest;
exports["default"] = _default;