"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The GameModel model module.
 * @module model/GameModel
 * @version 1.0.1
 */
var GameModel = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>GameModel</code>.
   * @alias module:model/GameModel
   */
  function GameModel() {
    _classCallCheck(this, GameModel);

    GameModel.initialize(this);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(GameModel, null, [{
    key: "initialize",
    value: function initialize(obj) {}
    /**
     * Constructs a <code>GameModel</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/GameModel} obj Optional instance to populate.
     * @return {module:model/GameModel} The populated <code>GameModel</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new GameModel();

        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }

        if (data.hasOwnProperty('walletId')) {
          obj['walletId'] = _ApiClient["default"].convertToType(data['walletId'], 'String');
        }

        if (data.hasOwnProperty('fundingWalletId')) {
          obj['fundingWalletId'] = _ApiClient["default"].convertToType(data['fundingWalletId'], 'String');
        }

        if (data.hasOwnProperty('email')) {
          obj['email'] = _ApiClient["default"].convertToType(data['email'], 'String');
        }

        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }

        if (data.hasOwnProperty('rpcs')) {
          obj['rpcs'] = _ApiClient["default"].convertToType(data['rpcs'], Object);
        }

        if (data.hasOwnProperty('publishedKey')) {
          obj['publishedKey'] = _ApiClient["default"].convertToType(data['publishedKey'], 'String');
        }

        if (data.hasOwnProperty('secretKey')) {
          obj['secretKey'] = _ApiClient["default"].convertToType(data['secretKey'], 'String');
        }

        if (data.hasOwnProperty('updatedAt')) {
          obj['updatedAt'] = _ApiClient["default"].convertToType(data['updatedAt'], 'String');
        }

        if (data.hasOwnProperty('createdAt')) {
          obj['createdAt'] = _ApiClient["default"].convertToType(data['createdAt'], 'String');
        }
      }

      return obj;
    }
  }]);

  return GameModel;
}();
/**
 * This field has not had a description added.
 * @member {String} id
 */


GameModel.prototype['id'] = undefined;
/**
 * This field has not had a description added.
 * @member {String} walletId
 */

GameModel.prototype['walletId'] = undefined;
/**
 * This field has not had a description added.
 * @member {String} fundingWalletId
 */

GameModel.prototype['fundingWalletId'] = undefined;
/**
 * This field has not had a description added.
 * @member {String} email
 */

GameModel.prototype['email'] = undefined;
/**
 * This field has not had a description added.
 * @member {String} name
 */

GameModel.prototype['name'] = undefined;
/**
 * This field has not had a description added.
 * @member {Object} rpcs
 */

GameModel.prototype['rpcs'] = undefined;
/**
 * This field has not had a description added.
 * @member {String} publishedKey
 */

GameModel.prototype['publishedKey'] = undefined;
/**
 * This field has not had a description added.
 * @member {String} secretKey
 */

GameModel.prototype['secretKey'] = undefined;
/**
 * This field has not had a description added.
 * @member {String} updatedAt
 */

GameModel.prototype['updatedAt'] = undefined;
/**
 * This field has not had a description added.
 * @member {String} createdAt
 */

GameModel.prototype['createdAt'] = undefined;
var _default = GameModel;
exports["default"] = _default;