"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The GetCurrencyFees200Response model module.
 * @module model/GetCurrencyFees200Response
 * @version 1.0.1
 */
var GetCurrencyFees200Response = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>GetCurrencyFees200Response</code>.
   * @alias module:model/GetCurrencyFees200Response
   */
  function GetCurrencyFees200Response() {
    _classCallCheck(this, GetCurrencyFees200Response);

    GetCurrencyFees200Response.initialize(this);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(GetCurrencyFees200Response, null, [{
    key: "initialize",
    value: function initialize(obj) {}
    /**
     * Constructs a <code>GetCurrencyFees200Response</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/GetCurrencyFees200Response} obj Optional instance to populate.
     * @return {module:model/GetCurrencyFees200Response} The populated <code>GetCurrencyFees200Response</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new GetCurrencyFees200Response();

        if (data.hasOwnProperty('recipientAddress')) {
          obj['recipientAddress'] = _ApiClient["default"].convertToType(data['recipientAddress'], 'String');
        }

        if (data.hasOwnProperty('basisPoints')) {
          obj['basisPoints'] = _ApiClient["default"].convertToType(data['basisPoints'], 'Number');
        }

        if (data.hasOwnProperty('fixedAmount')) {
          obj['fixedAmount'] = _ApiClient["default"].convertToType(data['fixedAmount'], 'Number');
        }

        if (data.hasOwnProperty('capAmount')) {
          obj['capAmount'] = _ApiClient["default"].convertToType(data['capAmount'], 'Number');
        }
      }

      return obj;
    }
  }]);

  return GetCurrencyFees200Response;
}();
/**
 * The wallet address that fees from all applicable transactions are automatically sent to.
 * @member {String} recipientAddress
 */


GetCurrencyFees200Response.prototype['recipientAddress'] = undefined;
/**
 * The number of fee basis points. 100 basisPoints = 1% fee of the total transaction amount deducted from the total received by the recipient.
 * @member {Number} basisPoints
 */

GetCurrencyFees200Response.prototype['basisPoints'] = undefined;
/**
 * The fixed number of currency as a fee regardless of the total transaction amount. 10 = 10 of the currency as a fee for any transaction, deducted from the total received by the recipient.
 * @member {Number} fixedAmount
 */

GetCurrencyFees200Response.prototype['fixedAmount'] = undefined;
/**
 * The maximum combined fee between basisPoints and fixedAmount. If the total transaction fee is over this amount, the capAmount will be used as the transaction fee deducted from the total received by the recipient.
 * @member {Number} capAmount
 */

GetCurrencyFees200Response.prototype['capAmount'] = undefined;
var _default = GetCurrencyFees200Response;
exports["default"] = _default;