"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The MintCurrencyRequest model module.
 * @module model/MintCurrencyRequest
 * @version 1.0.1
 */
var MintCurrencyRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>MintCurrencyRequest</code>.
   * @alias module:model/MintCurrencyRequest
   * @param amount {Number} The amount of currency to create (mint).
   */
  function MintCurrencyRequest(amount) {
    _classCallCheck(this, MintCurrencyRequest);

    MintCurrencyRequest.initialize(this, amount);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(MintCurrencyRequest, null, [{
    key: "initialize",
    value: function initialize(obj, amount) {
      obj['amount'] = amount;
    }
    /**
     * Constructs a <code>MintCurrencyRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/MintCurrencyRequest} obj Optional instance to populate.
     * @return {module:model/MintCurrencyRequest} The populated <code>MintCurrencyRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new MintCurrencyRequest();

        if (data.hasOwnProperty('amount')) {
          obj['amount'] = _ApiClient["default"].convertToType(data['amount'], 'Number');
        }

        if (data.hasOwnProperty('address')) {
          obj['address'] = _ApiClient["default"].convertToType(data['address'], 'String');
        }

        if (data.hasOwnProperty('walletId')) {
          obj['walletId'] = _ApiClient["default"].convertToType(data['walletId'], 'String');
        }
      }

      return obj;
    }
  }]);

  return MintCurrencyRequest;
}();
/**
 * The amount of currency to create (mint).
 * @member {Number} amount
 */


MintCurrencyRequest.prototype['amount'] = undefined;
/**
 * A valid EVM based address to create (mint) currency for. For example, `0x39cb70F972E0EE920088AeF97Dbe5c6251a9c25D`.
 * @member {String} address
 */

MintCurrencyRequest.prototype['address'] = undefined;
/**
 * Any wallet id within the MetaFab ecosystem to create (mint) currency for.
 * @member {String} walletId
 */

MintCurrencyRequest.prototype['walletId'] = undefined;
var _default = MintCurrencyRequest;
exports["default"] = _default;