"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The SetCurrencyFeesRequest model module.
 * @module model/SetCurrencyFeesRequest
 * @version 1.0.1
 */
var SetCurrencyFeesRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>SetCurrencyFeesRequest</code>.
   * @alias module:model/SetCurrencyFeesRequest
   * @param recipientAddress {String} The recipient address of currency transaction fees.
   * @param basisPoints {Number} A percentage fee for every transaction represented in basis points. To set a 1.5% fee, you would use a value of 150. This value can be 0, denoting no percentage fees.
   * @param fixedAmount {Number} A fixed fee for every transaction. A value of 0.5 would mean 0.5 of the currency of a transaction is always taken as a fee. This value can be 0, denoting no fixed fees.
   * @param capAmount {Number} The maximum fee amount for any single transaction. The total fee of a transaction is calculated as the sum of the basis points (percentage) fee, and fixed fee. If a calculated fee is greater than this maximum fee value, the maximum fee will be used instead.
   */
  function SetCurrencyFeesRequest(recipientAddress, basisPoints, fixedAmount, capAmount) {
    _classCallCheck(this, SetCurrencyFeesRequest);

    SetCurrencyFeesRequest.initialize(this, recipientAddress, basisPoints, fixedAmount, capAmount);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(SetCurrencyFeesRequest, null, [{
    key: "initialize",
    value: function initialize(obj, recipientAddress, basisPoints, fixedAmount, capAmount) {
      obj['recipientAddress'] = recipientAddress;
      obj['basisPoints'] = basisPoints;
      obj['fixedAmount'] = fixedAmount;
      obj['capAmount'] = capAmount;
    }
    /**
     * Constructs a <code>SetCurrencyFeesRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/SetCurrencyFeesRequest} obj Optional instance to populate.
     * @return {module:model/SetCurrencyFeesRequest} The populated <code>SetCurrencyFeesRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new SetCurrencyFeesRequest();

        if (data.hasOwnProperty('recipientAddress')) {
          obj['recipientAddress'] = _ApiClient["default"].convertToType(data['recipientAddress'], 'String');
        }

        if (data.hasOwnProperty('basisPoints')) {
          obj['basisPoints'] = _ApiClient["default"].convertToType(data['basisPoints'], 'Number');
        }

        if (data.hasOwnProperty('fixedAmount')) {
          obj['fixedAmount'] = _ApiClient["default"].convertToType(data['fixedAmount'], 'Number');
        }

        if (data.hasOwnProperty('capAmount')) {
          obj['capAmount'] = _ApiClient["default"].convertToType(data['capAmount'], 'Number');
        }
      }

      return obj;
    }
  }]);

  return SetCurrencyFeesRequest;
}();
/**
 * The recipient address of currency transaction fees.
 * @member {String} recipientAddress
 */


SetCurrencyFeesRequest.prototype['recipientAddress'] = undefined;
/**
 * A percentage fee for every transaction represented in basis points. To set a 1.5% fee, you would use a value of 150. This value can be 0, denoting no percentage fees.
 * @member {Number} basisPoints
 */

SetCurrencyFeesRequest.prototype['basisPoints'] = undefined;
/**
 * A fixed fee for every transaction. A value of 0.5 would mean 0.5 of the currency of a transaction is always taken as a fee. This value can be 0, denoting no fixed fees.
 * @member {Number} fixedAmount
 */

SetCurrencyFeesRequest.prototype['fixedAmount'] = undefined;
/**
 * The maximum fee amount for any single transaction. The total fee of a transaction is calculated as the sum of the basis points (percentage) fee, and fixed fee. If a calculated fee is greater than this maximum fee value, the maximum fee will be used instead.
 * @member {Number} capAmount
 */

SetCurrencyFeesRequest.prototype['capAmount'] = undefined;
var _default = SetCurrencyFeesRequest;
exports["default"] = _default;