"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The UpdatePlayerRequest model module.
 * @module model/UpdatePlayerRequest
 * @version 1.0.1
 */
var UpdatePlayerRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>UpdatePlayerRequest</code>.
   * @alias module:model/UpdatePlayerRequest
   */
  function UpdatePlayerRequest() {
    _classCallCheck(this, UpdatePlayerRequest);

    UpdatePlayerRequest.initialize(this);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(UpdatePlayerRequest, null, [{
    key: "initialize",
    value: function initialize(obj) {}
    /**
     * Constructs a <code>UpdatePlayerRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/UpdatePlayerRequest} obj Optional instance to populate.
     * @return {module:model/UpdatePlayerRequest} The populated <code>UpdatePlayerRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new UpdatePlayerRequest();

        if (data.hasOwnProperty('currentPassword')) {
          obj['currentPassword'] = _ApiClient["default"].convertToType(data['currentPassword'], 'String');
        }

        if (data.hasOwnProperty('newPassword')) {
          obj['newPassword'] = _ApiClient["default"].convertToType(data['newPassword'], 'String');
        }

        if (data.hasOwnProperty('resetAccessToken')) {
          obj['resetAccessToken'] = _ApiClient["default"].convertToType(data['resetAccessToken'], 'Boolean');
        }
      }

      return obj;
    }
  }]);

  return UpdatePlayerRequest;
}();
/**
 * The player's current password. Must be provided if setting `newPassword`.
 * @member {String} currentPassword
 */


UpdatePlayerRequest.prototype['currentPassword'] = undefined;
/**
 * A new password. The player's old password will no longer be valid.
 * @member {String} newPassword
 */

UpdatePlayerRequest.prototype['newPassword'] = undefined;
/**
 * Revokes the player's previous access token and returns a new one if true.
 * @member {Boolean} resetAccessToken
 */

UpdatePlayerRequest.prototype['resetAccessToken'] = undefined;
var _default = UpdatePlayerRequest;
exports["default"] = _default;