"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The V1CurrenciesCurrencyIdBurnsPostRequest model module.
 * @module model/V1CurrenciesCurrencyIdBurnsPostRequest
 * @version 1.0.0
 */
var V1CurrenciesCurrencyIdBurnsPostRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>V1CurrenciesCurrencyIdBurnsPostRequest</code>.
   * @alias module:model/V1CurrenciesCurrencyIdBurnsPostRequest
   * @param amount {Number} The amount of currency to remove (burn). The currency balance of the authenticating game or player's wallet must be equal to or greater than this amount.
   */
  function V1CurrenciesCurrencyIdBurnsPostRequest(amount) {
    _classCallCheck(this, V1CurrenciesCurrencyIdBurnsPostRequest);

    V1CurrenciesCurrencyIdBurnsPostRequest.initialize(this, amount);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(V1CurrenciesCurrencyIdBurnsPostRequest, null, [{
    key: "initialize",
    value: function initialize(obj, amount) {
      obj['amount'] = amount;
    }
    /**
     * Constructs a <code>V1CurrenciesCurrencyIdBurnsPostRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/V1CurrenciesCurrencyIdBurnsPostRequest} obj Optional instance to populate.
     * @return {module:model/V1CurrenciesCurrencyIdBurnsPostRequest} The populated <code>V1CurrenciesCurrencyIdBurnsPostRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new V1CurrenciesCurrencyIdBurnsPostRequest();

        if (data.hasOwnProperty('amount')) {
          obj['amount'] = _ApiClient["default"].convertToType(data['amount'], 'Number');
        }
      }

      return obj;
    }
  }]);

  return V1CurrenciesCurrencyIdBurnsPostRequest;
}();
/**
 * The amount of currency to remove (burn). The currency balance of the authenticating game or player's wallet must be equal to or greater than this amount.
 * @member {Number} amount
 */


V1CurrenciesCurrencyIdBurnsPostRequest.prototype['amount'] = undefined;
var _default = V1CurrenciesCurrencyIdBurnsPostRequest;
exports["default"] = _default;