"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The V1CurrenciesCurrencyIdTransfersPostRequest model module.
 * @module model/V1CurrenciesCurrencyIdTransfersPostRequest
 * @version 1.0.0
 */
var V1CurrenciesCurrencyIdTransfersPostRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>V1CurrenciesCurrencyIdTransfersPostRequest</code>.
   * @alias module:model/V1CurrenciesCurrencyIdTransfersPostRequest
   * @param amount {Number} The amount of currency to transfer.
   */
  function V1CurrenciesCurrencyIdTransfersPostRequest(amount) {
    _classCallCheck(this, V1CurrenciesCurrencyIdTransfersPostRequest);

    V1CurrenciesCurrencyIdTransfersPostRequest.initialize(this, amount);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(V1CurrenciesCurrencyIdTransfersPostRequest, null, [{
    key: "initialize",
    value: function initialize(obj, amount) {
      obj['amount'] = amount;
    }
    /**
     * Constructs a <code>V1CurrenciesCurrencyIdTransfersPostRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/V1CurrenciesCurrencyIdTransfersPostRequest} obj Optional instance to populate.
     * @return {module:model/V1CurrenciesCurrencyIdTransfersPostRequest} The populated <code>V1CurrenciesCurrencyIdTransfersPostRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new V1CurrenciesCurrencyIdTransfersPostRequest();

        if (data.hasOwnProperty('address')) {
          obj['address'] = _ApiClient["default"].convertToType(data['address'], 'String');
        }

        if (data.hasOwnProperty('walletId')) {
          obj['walletId'] = _ApiClient["default"].convertToType(data['walletId'], 'String');
        }

        if (data.hasOwnProperty('amount')) {
          obj['amount'] = _ApiClient["default"].convertToType(data['amount'], 'Number');
        }

        if (data.hasOwnProperty('reference')) {
          obj['reference'] = _ApiClient["default"].convertToType(data['reference'], 'Number');
        }
      }

      return obj;
    }
  }]);

  return V1CurrenciesCurrencyIdTransfersPostRequest;
}();
/**
 * A valid EVM based address to transfer currency to. For example, `0x39cb70F972E0EE920088AeF97Dbe5c6251a9c25D`.
 * @member {String} address
 */


V1CurrenciesCurrencyIdTransfersPostRequest.prototype['address'] = undefined;
/**
 * Any wallet id within the MetaFab ecosystem to transfer currency to.
 * @member {String} walletId
 */

V1CurrenciesCurrencyIdTransfersPostRequest.prototype['walletId'] = undefined;
/**
 * The amount of currency to transfer.
 * @member {Number} amount
 */

V1CurrenciesCurrencyIdTransfersPostRequest.prototype['amount'] = undefined;
/**
 * An optional uint256 number to reference the transfer. Commonly used to identify transfers intended to pay for game items or services.
 * @member {Number} reference
 */

V1CurrenciesCurrencyIdTransfersPostRequest.prototype['reference'] = undefined;
var _default = V1CurrenciesCurrencyIdTransfersPostRequest;
exports["default"] = _default;