"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The V1GamesGameIdPatchRequest model module.
 * @module model/V1GamesGameIdPatchRequest
 * @version 1.0.0
 */
var V1GamesGameIdPatchRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>V1GamesGameIdPatchRequest</code>.
   * @alias module:model/V1GamesGameIdPatchRequest
   */
  function V1GamesGameIdPatchRequest() {
    _classCallCheck(this, V1GamesGameIdPatchRequest);

    V1GamesGameIdPatchRequest.initialize(this);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(V1GamesGameIdPatchRequest, null, [{
    key: "initialize",
    value: function initialize(obj) {}
    /**
     * Constructs a <code>V1GamesGameIdPatchRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/V1GamesGameIdPatchRequest} obj Optional instance to populate.
     * @return {module:model/V1GamesGameIdPatchRequest} The populated <code>V1GamesGameIdPatchRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new V1GamesGameIdPatchRequest();

        if (data.hasOwnProperty('currentPassword')) {
          obj['currentPassword'] = _ApiClient["default"].convertToType(data['currentPassword'], 'String');
        }

        if (data.hasOwnProperty('newPassword')) {
          obj['newPassword'] = _ApiClient["default"].convertToType(data['newPassword'], 'String');
        }

        if (data.hasOwnProperty('rpcs')) {
          obj['rpcs'] = _ApiClient["default"].convertToType(data['rpcs'], {
            'String': 'String'
          });
        }

        if (data.hasOwnProperty('resetPublishedKey')) {
          obj['resetPublishedKey'] = _ApiClient["default"].convertToType(data['resetPublishedKey'], 'Boolean');
        }

        if (data.hasOwnProperty('resetSecretKey')) {
          obj['resetSecretKey'] = _ApiClient["default"].convertToType(data['resetSecretKey'], 'Boolean');
        }
      }

      return obj;
    }
  }]);

  return V1GamesGameIdPatchRequest;
}();
/**
 * The game's current password. Must be provided if setting `newPassword`.
 * @member {String} currentPassword
 */


V1GamesGameIdPatchRequest.prototype['currentPassword'] = undefined;
/**
 * A new password. The game's old password will no longer be valid.
 * @member {String} newPassword
 */

V1GamesGameIdPatchRequest.prototype['newPassword'] = undefined;
/**
 * Sets a custom RPC for your game to use instead of MetaFab's default RPCs for the chain(s) you specify.  Expects a JSON object containing key value pairs of supported `chain` -> `rpc url`. Only the chain names provided as keys in the object will be explicitly overriden. To delete a custom RPC for your game, provide the chain name to delete as a key in the provided object and `null` as the value.  Set RPC example, `{ MATIC: 'https://polygon-rpc.com' }` Delete RPC example, `{ MATIC: null }`
 * @member {Object.<String, String>} rpcs
 */

V1GamesGameIdPatchRequest.prototype['rpcs'] = undefined;
/**
 * Revokes the game's previous published key and returns a new one if true.
 * @member {Boolean} resetPublishedKey
 */

V1GamesGameIdPatchRequest.prototype['resetPublishedKey'] = undefined;
/**
 * Revokes the game's previous secret key and returns a new on if true.
 * @member {Boolean} resetSecretKey
 */

V1GamesGameIdPatchRequest.prototype['resetSecretKey'] = undefined;
var _default = V1GamesGameIdPatchRequest;
exports["default"] = _default;