"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The V1PlayersGetRequest model module.
 * @module model/V1PlayersGetRequest
 * @version 1.0.0
 */
var V1PlayersGetRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>V1PlayersGetRequest</code>.
   * @alias module:model/V1PlayersGetRequest
   * @param username {String} The players username, used to authenticate the player and if desired represent them in game. Usernames are unique. There cannot be 2 users with the same username created for a game.
   * @param password {String} The password to authenticate as the player. Additionally, this password is used to encrypt/decrypt a player's primary wallet and must be provided anytime this player makes blockchain interactions through various endpoints.
   */
  function V1PlayersGetRequest(username, password) {
    _classCallCheck(this, V1PlayersGetRequest);

    V1PlayersGetRequest.initialize(this, username, password);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(V1PlayersGetRequest, null, [{
    key: "initialize",
    value: function initialize(obj, username, password) {
      obj['username'] = username;
      obj['password'] = password;
    }
    /**
     * Constructs a <code>V1PlayersGetRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/V1PlayersGetRequest} obj Optional instance to populate.
     * @return {module:model/V1PlayersGetRequest} The populated <code>V1PlayersGetRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new V1PlayersGetRequest();

        if (data.hasOwnProperty('username')) {
          obj['username'] = _ApiClient["default"].convertToType(data['username'], 'String');
        }

        if (data.hasOwnProperty('password')) {
          obj['password'] = _ApiClient["default"].convertToType(data['password'], 'String');
        }
      }

      return obj;
    }
  }]);

  return V1PlayersGetRequest;
}();
/**
 * The players username, used to authenticate the player and if desired represent them in game. Usernames are unique. There cannot be 2 users with the same username created for a game.
 * @member {String} username
 */


V1PlayersGetRequest.prototype['username'] = undefined;
/**
 * The password to authenticate as the player. Additionally, this password is used to encrypt/decrypt a player's primary wallet and must be provided anytime this player makes blockchain interactions through various endpoints.
 * @member {String} password
 */

V1PlayersGetRequest.prototype['password'] = undefined;
var _default = V1PlayersGetRequest;
exports["default"] = _default;