"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * The WriteContractRequest model module.
 * @module model/WriteContractRequest
 * @version 1.0.1
 */
var WriteContractRequest = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>WriteContractRequest</code>.
   * @alias module:model/WriteContractRequest
   * @param func {String} A contract function name. This can be any valid function from the the ABI of the contract you are interacting with. For example, `mint`.
   */
  function WriteContractRequest(func) {
    _classCallCheck(this, WriteContractRequest);

    WriteContractRequest.initialize(this, func);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(WriteContractRequest, null, [{
    key: "initialize",
    value: function initialize(obj, func) {
      obj['func'] = func;
    }
    /**
     * Constructs a <code>WriteContractRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/WriteContractRequest} obj Optional instance to populate.
     * @return {module:model/WriteContractRequest} The populated <code>WriteContractRequest</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new WriteContractRequest();

        if (data.hasOwnProperty('func')) {
          obj['func'] = _ApiClient["default"].convertToType(data['func'], 'String');
        }

        if (data.hasOwnProperty('args')) {
          obj['args'] = _ApiClient["default"].convertToType(data['args'], 'String');
        }
      }

      return obj;
    }
  }]);

  return WriteContractRequest;
}();
/**
 * A contract function name. This can be any valid function from the the ABI of the contract you are interacting with. For example, `mint`.
 * @member {String} func
 */


WriteContractRequest.prototype['func'] = undefined;
/**
 * An array of args. This is optional and only necessary if the function being invoked requires arguments per the contract ABI. For example, `[123, \"Hello\", false]`.
 * @member {String} args
 */

WriteContractRequest.prototype['args'] = undefined;
var _default = WriteContractRequest;
exports["default"] = _default;